var q=Object.create;var c=Object.defineProperty;var v=Object.getOwnPropertyDescriptor;var x=Object.getOwnPropertyNames;var $=Object.getPrototypeOf,E=Object.prototype.hasOwnProperty;var B=(e,s)=>{for(var t in s)c(e,t,{get:s[t],enumerable:!0})},I=(e,s,t,r)=>{if(s&&typeof s=="object"||typeof s=="function")for(let n of x(s))!E.call(e,n)&&n!==t&&c(e,n,{get:()=>s[n],enumerable:!(r=v(s,n))||r.enumerable});return e};var l=(e,s,t)=>(t=e!=null?q($(e)):{},I(s||!e||!e.__esModule?c(t,"default",{value:e,enumerable:!0}):t,e)),D=e=>I(c({},"__esModule",{value:!0}),e);var C={};B(C,{StepResult:()=>u,createAgentTask:()=>y,default:()=>P,executeAgentTaskStep:()=>_,getAgentTask:()=>S,getAgentTaskStep:()=>A,listAgentTaskIDs:()=>g,listAgentTaskSteps:()=>T});module.exports=D(C);var w=l(require("express-openapi-validator")),p=l(require("express")),m=require("uuid"),R=l(require("js-yaml"));var k=`openapi: 3.0.1
info:
  title: Agent Communication Protocol
  description: Specification of the API protocol for communication with an agent.
  version: 'v1'

paths:
  /agent/tasks:
    post:
      summary: Creates a task for the agent.
      tags: [agent]
      operationId: createAgentTask
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/TaskRequestBody'
      responses:
        200:
          description: A new agent task was successfuly created.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Task'
        default:
          description: Internal Server Error
    get:
      summary: List all tasks that have been created for the agent.
      tags: [agent]
      operationId: listAgentTasksIDs
      responses:
        200:
          description: Returned list of agent's task IDs.
          content:
            application/json:
              schema:
                type: array
                default: []
                description: A list of task IDs
                items:
                  type: string
        default:
          description: Internal Server Error

  /agent/tasks/{task_id}:
    get:
      summary: Get details about a specified agent task.
      tags: [agent]
      operationId: getAgentTask
      parameters:
        - name: task_id
          in: path
          description: ID of the task
          required: true
          schema:
            type: string
      responses:
        200:
          description: Returned details about an agent task.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Task'
        default:
          description: Internal Server Error

  /agent/tasks/{task_id}/steps:
    get:
      summary: List all steps for the specified task.
      tags: [agent]
      operationId: listAgentTaskSteps
      parameters:
        - name: task_id
          in: path
          description: ID of the task
          required: true
          schema:
            type: string
      responses:
        200:
          description: Returned list of agent's step IDs for the specified task.
          content:
            application/json:
              schema:
                type: array
                default: []
                description: A list of step IDs for the task
                items:
                  type: string
        default:
          description: Internal Server Error
    post:
      summary: Execute a step in the specified agent task.
      tags: [agent]
      operationId: executeAgentTaskStep
      parameters:
        - name: task_id
          in: path
          description: ID of the task
          required: true
          schema:
            type: string
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/StepRequestBody'
      responses:
        200:
          description: Executed step for the agent task.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Step'
        default:
          description: Internal Server Error

  /agent/tasks/{task_id}/steps/{step_id}:
    get:
      summary: Get details about a specified task step.
      tags: [agent]
      operationId: getAgentTaskStep
      parameters:
        - name: task_id
          in: path
          description: ID of the task
          required: true
          schema:
            type: string
        - name: step_id
          in: path
          description: ID of the step
          required: true
          schema:
            type: string
      responses:
        200:
          description: Returned details about an agent task step.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Step'
        default:
          description: Internal Server Error

components:
  schemas:
    TaskInput:
      description: Input parameters for the task. Any value is allowed.

    Artifact:
      description: Artifact that the task has produced. Any value is allowed.

    StepInput:
      description: Input parameters for the task step. Any value is allowed.

    StepOutput:
      description: Output that the task step has produced. Any value is allowed.

    TaskRequestBody:
      type: object
      description: Body of the task request.
      properties:
        input:
          $ref: '#/components/schemas/TaskInput'

    Task:
      allOf:
        - $ref: '#/components/schemas/TaskRequestBody'
        - type: object
          description: Definition of an agent task.
          required:
            - 'task_id'
          properties:
            task_id:
              description: The ID of the task.
              type: string
            artifacts:
              type: array
              default: []
              description: A list of artifacts that the task has produced.
              items:
                $ref: '#/components/schemas/Artifact'

    StepRequestBody:
      type: object
      description: Body of the task request.
      properties:
        input:
          $ref: '#/components/schemas/StepInput'

    StepResult:
      description: Result of the task step.
      type: object
      required:
        - 'artifacts'
      properties:
        output:
          $ref: '#/components/schemas/StepOutput'
        artifacts:
          type: array
          default: []
          description: A list of artifacts that the step has produced.
          items:
            $ref: '#/components/schemas/Artifact'
        is_last:
          description: Whether this is the last step in the task.
          type: boolean
          default: false

    Step:
      allOf:
        - $ref: '#/components/schemas/StepRequestBody'
        - $ref: '#/components/schemas/StepResult'
        - type: object
          required:
            - 'step_id'
            - 'task_id'
          properties:
            task_id:
              description: The ID of the task this step belongs to.
              type: string
            step_id:
              description: The ID of the task step.
              type: string
`;var a=(0,p.default)();a.use(p.default.json());a.use(p.default.text());a.use(p.default.urlencoded({extended:!1}));a.get("/openapi.yaml",(e,s)=>{s.setHeader("Content-Type","text/yaml").status(200).send(k)});var O=R.default.load(k);a.use(w.middleware({apiSpec:O,validateRequests:!0,validateResponses:!0}));var i=[],h=[],f=null,u=class{constructor(){this.output=null;this.artifacts=[];this.is_last=!1}},y=async e=>{if(f==null)throw new Error("Task handler not defined");let s=await f((e==null?void 0:e.input)??null),t={task_id:(0,m.v4)(),input:(e==null?void 0:e.input)??null,artifacts:[]};return i.push([t,s]),t};a.post("/agent/tasks",(e,s)=>{(async()=>{try{let t=await y(e.body);s.status(200).json(t)}catch(t){console.error(t),s.status(500).json({error:t.message})}})()});var g=async()=>i.map(([e,s])=>e.task_id);a.get("/agent/tasks",(e,s)=>{(async()=>{try{let t=await g();s.status(200).json(t)}catch(t){console.error(t),s.status(500).json({error:t.message})}})()});var S=async e=>{let s=i.find(([t,r])=>t.task_id===e);if(s==null)throw new Error(`Task with id ${e} not found`);return s[0]};a.get("/agent/tasks/:task_id",(e,s)=>{(async()=>{try{let t=await S(e.params.task_id);s.status(200).json(t)}catch(t){console.error(t),s.status(500).json({error:t.message})}})()});var T=async e=>{if(i.find(([t,r])=>t.task_id===e)==null)throw new Error(`Task with id ${e} not found`);return h.filter(t=>t.task_id===e).map(t=>t.step_id)};a.get("/agent/tasks/:task_id/steps",(e,s)=>{(async()=>{try{let t=await T(e.params.task_id);s.status(200).json(t)}catch(t){console.error(t),s.status(500).json({error:t.message})}})()});var _=async(e,s)=>{let t=i.find(([j,G])=>j.task_id===e);if(t==null)throw new Error(`Task with id ${e} not found`);let r=t[1],n=await r((s==null?void 0:s.input)??null),o={task_id:e,step_id:(0,m.v4)(),input:(s==null?void 0:s.input)??null,output:n.output??null,artifacts:n.artifacts??[],is_last:n.is_last??!1};return o.artifacts!=null&&(t[0].artifacts==null||t[0].artifacts.length===0?t[0].artifacts=o.artifacts:t[0].artifacts.push(...o.artifacts)),h.push(o),o};a.post("/agent/tasks/:task_id/steps",(e,s)=>{(async()=>{try{let t=await _(e.params.task_id,e.body);s.status(200).json(t)}catch(t){console.error(t),s.status(500).json({error:t.message})}})()});var A=async(e,s)=>{let t=h.find(r=>r.task_id===e&&r.step_id===s);if(t==null)throw new Error(`Step with task id ${e} and step id ${s} not found`);return t};a.get("/agent/tasks/:task_id/steps/:step_id",(e,s)=>{(async()=>{try{let t=await A(e.params.task_id,e.params.step_id);s.status(200).json(t)}catch(t){console.error(t),s.status(500).json({error:t.message})}})()});var d=class{static handleTask(s){return f=s,this}static start(s=8e3){a.listen(s,()=>{console.log(`Agent listening at http://localhost:${s}`)})}};var P=d;0&&(module.exports={StepResult,createAgentTask,executeAgentTaskStep,getAgentTask,getAgentTaskStep,listAgentTaskIDs,listAgentTaskSteps});
//# sourceMappingURL=index.js.map